#include <bits/stdc++.h>

#define int long long
using namespace std;



int32_t main(){
    ios_base::sync_with_stdio(0); cin.tie(0);cout.tie(0);
    int n;
    cin >>n;
    vector<int>a(n);
    for (int i=0;i<n;i++) cin >>a[i];

    vector<int>t(n);
    t[0]=1;
    int x=1;
    for (int i=1;i<n;i++){
        if (a[i] >= a[i-1]) t[i]=x;
        else{
            if (a[i-1] <= a[i+1]) t[i]=x;
            else{
                if (x==0) x=1;
                else if (x==1) x=0;
                t[i]=x;
            }
        }
    }

    vector<int>pf(n);
    pf[0]=t[0];
    for (int i=1;i<n;i++){
        pf[i]=pf[i-1]+t[i];
    }
    int q,sum, l, r;
    cin >>q;
    while (q--){
        cin >>l>>r;
        l--;r--;
        if (l==0) sum=pf[r];
        else sum = pf[r]-pf[l-1];

       // if (l==3 && r==5) cout <<sum<<endl;

        if (sum==0) cout <<"DA\n";
        else if (sum + 1 == r-l+1) cout <<"DA\n";
        else if (sum == r-l+1) cout <<"DA\n";
        else if (sum == 1) cout <<"DA\n";
        else cout <<"NE\n";
    }

    return 0;
}